---
date: "2021-05-28T22:16:44Z"
title: IPng arrives in Lille
aliases:
- /s/articles/2021/05/28/lille.html
---

I've been planning a network expansion for a while now. For the next few weeks,
I will be in total geek-mode as I travel to several European cities to deploy
AS50869 on a european ring. At the same time, my buddy Fred from
[IP-Max](https://ip-max.net/) has been wanting to go to Amsterdam. IP-Max's
[network](https://as25091.peeringdb.com/) is considerably larger than mine, but
it just never clicked with the right set of circumstances for them to deploy
in the Netherlands, until the stars aligned ...

## Deployment

{{< image width="300px" float="right" src="/assets/network/lille-civ1.png" alt="Lille CIV1" >}}

After our adventure in [Amsterdam]({{< ref "2021-05-26-amsterdam" >}}), and
after Fred and I both got negative PCR test results, we made our way down to
Lille, France. There are two datacenters there where IP-Max has a presence,
and they are very innovative ones. There's a specific trick with a block of
frozen ice that allows for the facility cooling to run autonomously in case
of a chiller or power failure. I got to see the storage of the icecube :)

Now, because Fred is possibly even more enthusiastic about our eurotrip than
I am, he insisted that I also put a machine here in Lille, even though
originally it was meant to be only Frankfurt, Amsterdam, Paris and Zurich.
After some tough negotiations, I reluctantly agreed. While I did not have a
Supermicro, I did have some freshly procured Dell R610s, the old machines
from Coloclue AS8283, which they have recently upgraded to newer routers.
I installed the pair at EUNetworks for Coloclue, and another team mate
installed the pair at DCG/NorthC, after which four of these units were left
written off and available. And I would not be me, if I were not to accept
some perfectly valuable second hand vintage Dells :-)

So the plan is: we drop an R610 here now, and I ship a replacement _standard
issue_ Supermicro + APU3d3/WiFi later.

### Connectivity

{{< image width="300px" float="right" src="/assets/network/frggh0-rack.png" alt="Lille Rack" >}}

By now I'm getting pretty good ad creating L2VPN EoMPLS circuits, so I
created one for myself from the Amsterdam router **er01.ams01.ip-max.net**
to the one here at **er01.lil01.ip-max.net**. The one here is a Cisco
ASR9006, a respectable machine. In the second point of presence, in
the neighboring town of Anzin, there is an ASR9010 called **er01.lil02.ip-max.net**
but that one is tucked away in a telco room reserved for deities, not
in the normal serverroom which is available for _plebs_ like me.

The inbound span goes from Amsterdam through Antwerp (Belgium) and Brussels
and finally landing in Anzin, and from there it's dark fiber to this rack.
I realised that because I use [UN/LOCODE](https://unece.org/trade/cefact/unlocode-code-list-country-and-territory)
that I should be precise in my naming. The town here is a suburb of Lille,
the country's fourth biggest city after Paris, Marseille and Lyon. The
town itself is called Sainghin-en-M&eacute;lantois, which resolves to
**FR GGH** and thus my temporary Dell R610 will be called **frggh0.ipng.ch**.

Fred happened to have a spare Intel X552 in his bag, so I commandeered it and
gave the machine two legs of Tengig, one going to the ASR9006 and the other
going the Nexus3064PQ under it. Soon, we will connect here to the local
internet exchange [Lillix](https://www.lillix.fr/membres/). There are very
few non-locals, let alone international members at LilleIX, but considering
larger clubs like Zayo require two or more french peering points, this will
be my ticket to some pretty good peers. Nice!

The idea is that one VLL lands me on Amsterdam, and the other will eventually
land me on Paris at Telehouse TH2. But that will be after the weekend, as
first we need to spend some quality time exploring Lille and recreating the
_grignotage_ (English: nibbling) that must be done in the north of France.

## The results

As always on the IP-Max network, they speak for themselves. During daytime,
the connectivity from my basement to Frankfurt is at 6.7ms, to Amsterdam
it's 13ms and all the way to Lille it's 20.3ms, with throughputs that
are, let's just say, _line rate_ **booyah**!

```
pim@chumbucket:~$ traceroute frggh0.ipng.ch
traceroute to frggh0.ipng.ch (194.1.163.34), 30 hops max, 60 byte packets
 1  chbtl1.ipng.ch (194.1.163.67)  0.246 ms  0.214 ms  0.135 ms
 2  chgtg0.ipng.ch (194.1.163.19)  0.513 ms  0.478 ms  0.445 ms
 3  chrma0.ipng.ch (194.1.163.8)  0.633 ms  0.599 ms  0.658 ms
 4  defra0.ipng.ch (194.1.163.25)  6.808 ms  6.773 ms  6.740 ms
 5  nlams0.ipng.ch (194.1.163.27)  13.090 ms  13.057 ms  13.024 ms
 6  frggh0.ipng.ch (194.1.163.34)  20.370 ms  20.550 ms  20.473 ms

pim@frggh0:~$ iperf3 -c chrma0.ipng.ch -P 10 -R
...
[SUM]   0.00-10.02  sec  8.84 GBytes  7.58 Gbits/sec  271             sender
[SUM]   0.00-10.00  sec  8.75 GBytes  7.52 Gbits/sec                  receiver

pim@defra0:~$ iperf3 -P 10 -c frggh0.ipng.ch -R
...
[SUM]   0.00-10.02  sec  11.1 GBytes  9.54 Gbits/sec  292             sender
[SUM]   0.00-10.00  sec  11.1 GBytes  9.51 Gbits/sec                  receiver
```

After the weekend, we'll be driving on to Paris to complete the ring, after
which I will have two different ways to traverse -- clockwise from
Zurich to Geneva, Paris, Lille, Amsterdam and Frankfurt, or counterclockwise
on the same ring. There will be 10Gbit between each of my routers in each
direction. We do not compromise on quality, throughput or latency over here.

I could not be happier with the service provided so far. Paris, here we come!!
